#include <stdio.h>
#include <stdlib.h>

using namespace std;

const int maxN = 20000, maxP = 2001;

struct meda { int start, end, cena; };

int n;
long long minCena;
meda mede[maxN];
int kupili[maxP], pom[maxP];

int komparatorPoCeni(const void *a, const void *b) {
    meda *m1 = (meda*)a;
    meda *m2 = (meda*)b;
    return (int)(m2 -> cena - m1 -> cena);
} 

int main() {
    freopen("mede.in", "r", stdin);
    freopen("mede.out", "w", stdout);

    scanf("%d", &n);
    for (int i = 0; i < n; i++) 
        scanf("%d%d%d", &(mede[i].start), &(mede[i].end), &(mede[i].cena));
    
    // sortiramo mede po ceni, od najskupljeg do najjeftinijeg
    qsort(mede, n, sizeof(meda), komparatorPoCeni); 
        
    // na pocetku su nam sve prodavnice slobodne    
    for (int i = 0; i < maxP; i++)
        kupili[i] = -1;
    minCena = 0;
    
    for (int i = 0; i < n; i++) {
        // pokusavamo da dobijemo i-tog medu
        int tekMeda = i;
        int tekP = mede[i].start;    

        // prekidamo ako smo naisli na praznu prodavnicu ili ako nemamo vise prodavnica u kojima se
        // tekuci meda prodaje
        while ((tekMeda >= 0) && (tekP <= mede[tekMeda].end)) 
            if (kupili[tekP] == -1) {
                // ukoliko imamo slobodnu prodavnicu dodelicemo medu njoj i zavrsiti
                pom[tekP] = tekMeda;
                tekMeda = -1;              
            } else {
                if (mede[tekMeda].end < mede[kupili[tekP]].end) {
                    // ako se meda kupljen u prodavnici koju trenutno posmatramo prodaje u vise prodavnica
                    // nego meda kojeg pokusavamo da dodamo, onda cemo njega uzeti kao tekuceg medu, a naseg
                    // medu kupiti u ovoj prodavnici
                    pom[tekP] = tekMeda;
                    tekMeda = kupili[tekP];           
                } else pom[tekP] = kupili[tekP];
                tekP++; // prelazimo na sledecu prodavnicu  
            }
            
        if (tekMeda < 0) 
            // ako smo imali slobodnu prodavnicu za medu, treba samo promene da sacuvamo
            for (int j = mede[i].start; j <= tekP; j++)
                kupili[j] = pom[j];
        else 
            // nismo uspeli da dodamo i-tog medu, treba da povecamo cenu meda koje ne mozemo dobiti
            minCena += mede[i].cena;
            // stanje prodavnica ostaje kakvo je bilo
    }
        
    printf("%lld\n", minCena);
    return 0;   
}
